      subroutine getlun(number)
c
      parameter (MAX_OPEN = 64)
      logical attached, reserved
      number = 0
      num_open = 0
      do while (num_open .le. MAX_OPEN)
         inquire(unit=number, opened=attached)
         reserved = number .eq. 0 .or. number .eq. 5 .or. number .eq. 6
         if (.not. attached .and. .not. reserved) return
         num_open = num_open + 1
         number = number + 1
      end do
      stop 'Too many open files'
      end
      subroutine chgcase(string)
      character string*(*)
c
c  Reverse the case of the alphabetic characters in the given string;
c  enter at makcap or at maklow to make all characters the same case.
c
      character small*26, capital*26
      data small / 'abcdefghijklmnopqrstuvwxyz' /
      data capital / 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' /
c
      do 100 i=1, len(string)
         k = index(small,string(i:i))
         if (k .gt. 0) then
            string(i:i) = capital(k:k)
         else
            k = index(capital,string(i:i))
            if (k .gt. 0) string(i:i) = small(k:k)
         end if
  100 continue
      return 
c
      entry maklow(string)
      do 200 i=1, len(string)
         k = index(capital,string(i:i))
         if (k .gt. 0) string(i:i) = small(k:k)
  200 continue
      return 
c
      entry makcap(string)
      do 300 i=1, len(string)
         k = index(small,string(i:i))
         if (k .gt. 0) string(i:i) = capital(k:k)
  300 continue
      return 
      end
      subroutine announce(announcement, hours, lun)
      character*(*) announcement
c
c  Reproduce an announcement string and a formatted time on logical unit lun.
c  The time will appear in the character position set by parameter ITAB with
c  four decimal digits for the integer value of hours.
c
      parameter(ITAB = 58)
      character time_string*10
c
      write(time_string, 1000) int(hours),
     &   int(60*mod(hours, 1.0)),
     &   int(60*mod(60*mod(hours, 1.0), 1.0))
      write(lun, 1002) announcement(1:lnblnk(announcement)),
     &   time_string
      return
 1000 format(i4, ':', i2.2, ':', i2.2)
 1002 format(a, t<ITAB>, a)
      end
      real function flog10(x)
c
c  Quick evaluation of log base 10.  Presumes x not greater
c  than unity. Maximum absolute error = log10(1.005).
c
      real flog10_lookup(100:1000)
      save flog10_lookup
      data flog10_lookup(100) /-1.0/
      nint(x) = int(2*(x+0.5))/2
c
      if (flog10_lookup(100) .lt. 0.0) then
         do 10 n=100, 1000
            flog10_lookup(n) = log10(real(n))
   10    continue
      end if
      if (x .gt. 1.0) stop 'Arg out of range in flog10'
c
      y = 1000*x
      i = nint(y)
      n = 3
      do while (i .lt. 100)
         y = 10*y
         n = n + 1
         i = nint(y)
      end do
      flog10 = flog10_lookup(i) - n
      return
      end
      subroutine itplbv(lx,ly,x,y,z,n,u,v,w)
c
c  Bivariate interpolation routine due to Hiroshi Akima, Communications
c  of the ACM, Vol. 17, No. 1, January 1974
c
c  This subroutine interpolates, from values of the function given
c  at input grid points in an xy-plane and for a given set of points
c  in the plane, the values of a single-valued bivariate function
c  z = z(x, y).
c
c  The method is based on a piece-wise function composed of a set of
c  bicubic polynomials in x and y. Each polynomial is applicable to
c  a rectangle of the input grid in the xy plane. Each polynomial is
c  determined locally.
c
c  The input parameters are:
c
c     Lx = Number of input grid points in the x coordinate
c          (must be 2 or greater)
c     Ly = Number of input grid points in the y coordinate
c          (must be 2 or greater)
c     x  = Array of dimension Lx storing the x coordinates
c          of input grid points (in ascending order)
c     y  = Array of dimension Ly storing the y coordinates
c          of input grid points (in ascending order)
c     z  = doubly dimensioned array of dimension (Lx, Ly)
c          storing the values of the function (z values) at
c          input grid points.
c     n  = Number of points at which interpolation of the
c          z value is desired (must be 1 or greater)
c     u  = Array of dimension n storing the x coordinates
c          of desired points
c     v  = Array of dimension n storing the y coordinates
c          of desired points
c 
c  The output is:
c
c     w  = Array of dimension n where the interpolated z values
c          at desired points are to be displayed
c
c  Some variables internally used are:
c
c     za = Divided difference of z with respect to x
c     zb = Divided difference of z with respect to y
c     zab= Second order difference of z with respect to x and y
c     zx = Partial derivative of z with respect to x
c     zy = Partial derivative of z with respect to y
c     zxy= Second order partial derivative of z with respect to x, y
c
      real x(lx),y(ly),z(lx,ly),u(n),v(n),w(n)
      real za(5,2),zb(2,5),zab(3,3),zx(4,4),zy(4,4),zxy(4,4)
      equivalence (z3a1,za(1)),(z3a2,za(2)),(z3a3,za(3)),(z3a4,za(4)),
     &(z3a5,za(5)),(z4a1,za(6)),(z4a2,za(7)),(z4a3,za(8)),(z4a4,za(9)),
     &(z4a5,za(10)),(z3b1,zb(1)),(z3b2,zb(3)),(z3b3,zb(5)),(z3b4,zb(7)),
     &(z3b5,zb(9)),(z4b1,zb(2)),(z4b2,zb(4)),(z4b3,zb(6)),(z4b4,zb(8)),
     &(z4b5,zb(10)),(za2b2,zab(1)),(za3b2,zab(2)),(za4b2,zab(3)),(za2b3,
     &zab(4)),(za3b3,zab(5)),(za4b3,zab(6)),(za2b4,zab(7)),(za3b4,zab(8)
     &),(za4b4,zab(9)),(zx33,zx(6)),(zx43,zx(7)),(zx34,zx(10)),(zx44,zx(
     &11)),(zy33,zy(6)),(zy43,zy(7)),(zy34,zy(10)),(zy44,zy(11)),(zxy33,
     &zxy(6)),(zxy43,zxy(7)),(zxy34,zxy(10)),(zxy44,zxy(11)),(p00,z33),
     &(p01,zy33),(p10,zx33),(p11,zxy33)
      equivalence (lx0,zx(1)),(lxm1,zx(4)),(lxm2,zx(13)),(lxp1,zx(16)),
     &(ly0,zy(1)),(lym1,zy(4)),(lym2,zy(13)),(lyp1,zy(16)),(ix,zxy(1)),
     &(iy,zxy(4)),(ixpv,zxy(13)),(iypv,zxy(16)),(imn,jx),(imx,jy),(jxm2,
     &jx1),(jym2,jy1),(uk,dx),(vk,dy),(a1,a5,b1,b5,zx(2),a,q0),(a2,zx(5)
     &,b,q1),(a4,zx(8),c,q2),(b2,zy(2),d,q3),(b4,zy(14),e),(x2,zx(3),a3s
     &q),(x4,zx(9)),(x5,zx(12)),(y2,zx(14)),(y4,zy(3),b3sq),(y5,zx(15),
     &p02),(z23,zy(5),p03),(z24,zy(8),p12),(z32,zy(9),p13),(z34,zy(12),
     &p20),(z35,zy(15),p21),(z42,zxy(2),p22),(z43,zxy(5),p23),(z44,zxy(3
     &),p30),(z45,zxy(8),p31),(z53,zxy(9),p32),(z54,zxy(12),p33),(w2,wy2
     &,w4),(w3,wy3,w1,w5),(wx2,zxy(14)),(wx3,zxy(15))
c
c  PRELIMINARY PROCESSING:
c  SETTING OF SOME INPUT PARAMETERS TO LOCAL VARIABLES
c
      lx0=lx
      lxm1=lx0-1
      lxm2=lxm1-1
      lxp1=lx0+1
      ly0=ly
      lym1=ly0-1
      lym2=lym1-1
      lyp1=ly0+1
      n0=n
c
c  ERROR CHECK
c
      if(lxm2.lt.0) go to 710
      if(lym2.lt.0) go to 720
      if(n0.lt.1) go to 730
      do 10 ix=2,lx0
        if(x(ix-1)-x(ix))10,740,750
   10 continue
      do 20 iy=2,ly0
        if(y(iy-1)-y(iy))20,770,780
   20 continue
c
c  INITIAL SETTING OF PREVIOUS VALUES OF IX AND IY
c
      ixpv=0
      iypv=0
c
c  MAIN LOOP
c
      do 700 k=1,n0
        uk=u(k)
        vk=v(k)
c
c  ROUTINES TO LOCATE THE DESIRED POINT
c  - FIND THE IX VALUE FOR WHICH U(K) >= X(IX-1)
c    AND U(K) < X(IX)
c
        if(lxm2.eq.0) go to 80
        if(uk.ge.x(lx0)) go to 70
        if(uk.lt.x(1)) go to 60
        imn=2
        imx=lx0
   30   ix=(imn+imx)/2
        if(uk.ge.x(ix)) go to 40
        imx=ix
        go to 50
c
   40   imn=ix+1
   50   if(imx.gt.imn) go to 30
        ix=imx
        go to 90
c
   60   ix=1
        go to 90
c
   70   ix=lxp1
        go to 90
c
   80   ix=2
c
c  - FIND THE IY VALUE FOR WHICH V(K) >= Y(IY-1)
c    AND V(K) < Y(IY)
c
   90   if(lym2.eq.0) go to 150
        if(vk.ge.y(ly0)) go to 140
        if(vk.lt.y(1)) go to 130
        imn=2
        imx=ly0
  100   iy=(imn+imx)/2
        if(vk.ge.y(iy)) go to 110
        imx=iy
        go to 120
c
  110   imn=iy+1
  120   if(imx.gt.imn) go to 100
        iy=imx
        go to 160
c
  130   iy=1
        go to 160
c
  140   iy=lyp1
        go to 160
c
  150   iy=2
c
c  - CHECK IF THE DESIRED POINT IS IN THE SAME RECTANGLE
c    AS THE PREVIOUS POINT. IF YES, SKIP TO THE COMPUTATION
c    OF THE POLYNOMIAL
c
  160   if(ix.eq.ixpv.and.iy.eq.iypv) go to 690
        ixpv=ix
        iypv=iy
c
c  ROUTINES TO PICK UP NECESSARY X, Y, AND Z VALUES, TO
c  COMPUTE THE ZA, ZB, AND ZAB VALUES, AND TO ESTIMATE THEM
c  WHEN NECESSARY
c
        jx=ix
        if(jx.eq.1)jx=2
        if(jx.eq.lxp1)jx=lx0
        jy=iy
        if(jy.eq.1)jy=2
        if(jy.eq.lyp1)jy=ly0
        jxm2=jx-2
        jxml=jx-lx0
        jym2=jy-2
        jyml=jy-ly0
c
c  - IN THE CORE AREA, I.E., IN THE RECTANGLE THAT CONTAINS
c    THE DESIRED POINT
c
        x3=x(jx-1)
        x4=x(jx)
        a3=1.0/(x4-x3)
        y3=y(jy-1)
        y4=y(jy)
        b3=1.0/(y4-y3)
        z33=z(jx-1,jy-1)
        z43=z(jx,jy-1)
        z34=z(jx-1,jy)
        z44=z(jx,jy)
        z3a3=(z43-z33)*a3
        z4a3=(z44-z34)*a3
        z3b3=(z34-z33)*b3
        z4b3=(z44-z43)*b3
c
c  - IN THE X DIRECTION
c
        za3b3=(z4b3-z3b3)*a3
        if(lxm2.eq.0) go to 230
        if(jxm2.eq.0) go to 170
        x2=x(jx-2)
        a2=1.0/(x3-x2)
        z23=z(jx-2,jy-1)
        z24=z(jx-2,jy)
        z3a2=(z33-z23)*a2
        z4a2=(z34-z24)*a2
        if(jxml.eq.0) go to 180
  170   x5=x(jx+1)
        a4=1.0/(x5-x4)
        z53=z(jx+1,jy-1)
        z54=z(jx+1,jy)
        z3a4=(z53-z43)*a4
        z4a4=(z54-z44)*a4
        if(jxm2.ne.0) go to 190
        z3a2=z3a3+z3a3-z3a4
        z4a2=z4a3+z4a3-z4a4
        go to 190
c
  180   z3a4=z3a3+z3a3-z3a2
        z4a4=z4a3+z4a3-z4a2
  190   za2b3=(z4a2-z3a2)*b3
        za4b3=(z4a4-z3a4)*b3
        if(jx.le.3) go to 200
        a1=1.0/(x2-x(jx-3))
        z3a1=(z23-z(jx-3,jy-1))*a1
        z4a1=(z24-z(jx-3,jy))*a1
        go to 210
c
  200   z3a1=z3a2+z3a2-z3a3
        z4a1=z4a2+z4a2-z4a3
  210   if(jx.ge.lxm1) go to 220
        a5=1.0/(x(jx+2)-x5)
        z3a5=(z(jx+2,jy-1)-z53)*a5
        z4a5=(z(jx+2,jy)-z54)*a5
        go to 240
c
  220   z3a5=z3a4+z3a4-z3a3
        z4a5=z4a4+z4a4-z4a3
        go to 240
c
  230   z3a2=z3a3
        z4a2=z4a3
        go to 180
c
c  - IN THE Y DIRECTION
c
  240   if(lym2.eq.0) go to 310
        if(jym2.eq.0) go to 250
        y2=y(jy-2)
        b2=1.0/(y3-y2)
        z32=z(jx-1,jy-2)
        z42=z(jx,jy-2)
        z3b2=(z33-z32)*b2
        z4b2=(z43-z42)*b2
        if(jyml.eq.0) go to 260
  250   y5=y(jy+1)
        b4=1.0/(y5-y4)
        z35=z(jx-1,jy+1)
        z45=z(jx,jy+1)
        z3b4=(z35-z34)*b4
        z4b4=(z45-z44)*b4
        if(jym2.ne.0) go to 270
        z3b2=z3b3+z3b3-z3b4
        z4b2=z4b3+z4b3-z4b4
        go to 270
c
  260   z3b4=z3b3+z3b3-z3b2
        z4b4=z4b3+z4b3-z4b2
  270   za3b2=(z4b2-z3b2)*a3
        za3b4=(z4b4-z3b4)*a3
        if(jy.le.3) go to 280
        b1=1.0/(y2-y(jy-3))
        z3b1=(z32-z(jx-1,jy-3))*b1
        z4b1=(z42-z(jx,jy-3))*b1
        go to 290
c
  280   z3b1=z3b2+z3b2-z3b3
        z4b1=z4b2+z4b2-z4b3
  290   if(jy.ge.lym1) go to 300
        b5=1.0/(y(jy+2)-y5)
        z3b5=(z(jx-1,jy+2)-z35)*b5
        z4b5=(z(jx,jy+2)-z45)*b5
        go to 320
c
  300   z3b5=z3b4+z3b4-z3b3
        z4b5=z4b4+z4b4-z4b3
        go to 320
c
  310   z3b2=z3b3
        z4b2=z4b3
        go to 260
c
c  - IN THE DIAGONAL DIRECTIONS
c
  320   if(lxm2.eq.0) go to 400
        if(lym2.eq.0) go to 410
        if(jxml.eq.0) go to 350
        if(jym2.eq.0) go to 330
        za4b2=((z53-z(jx+1,jy-2))*b2-z4b2)*a4
        if(jyml.eq.0) go to 340
  330   za4b4=((z(jx+1,jy+1)-z54)*b4-z4b4)*a4
        if(jym2.ne.0) go to 380
        za4b2=za4b3+za4b3-za4b4
        go to 380
c
  340   za4b4=za4b3+za4b3-za4b2
        go to 380
c
  350   if(jym2.eq.0) go to 360
        za2b2=(z3b2-(z23-z(jx-2,jy-2))*b2)*a2
        if(jyml.eq.0) go to 370
  360   za2b4=(z3b4-(z(jx-2,jy+1)-z24)*b4)*a2
        if(jym2.ne.0) go to 390
        za2b2=za2b3+za2b3-za2b4
        go to 390
c
  370   za2b4=za2b3+za2b3-za2b2
        go to 390
c
  380   if(jxm2.ne.0) go to 350
        za2b2=za3b2+za3b2-za4b2
        za2b4=za3b4+za3b4-za4b4
        go to 420
c
  390   if(jxml.ne.0) go to 420
        za4b2=za3b2+za3b2-za2b2
        za4b4=za3b4+za3b4-za2b4
        go to 420
c
  400   za2b2=za3b2
        za4b2=za3b2
        za2b4=za3b4
        za4b4=za3b4
        go to 420
c
  410   za2b2=za2b3
        za2b4=za2b3
        za4b2=za4b3
        za4b4=za4b3
c
c  NUMERICAL DIFFERENTIATION --- TO DETERMINE PARTIAL
c  DERIVATIVES ZX, ZY, AND AXY AS WEIGHTED MEANS OF DIVIDED
c  DIFERENCES ZA, ZB, AND ZAB RESPECTIVELY
c
  420   do 480 jy=2,3
          do 470 jx=2,3
          w2=abs(za(jx+2,jy-1)-za(jx+1,jy-1))
          w3=abs(za(jx,jy-1)-za(jx-1,jy-1))
          sw=w2+w3
          if(sw.lt..0000001) go to 430
          wx2=w2/sw
          wx3=w3/sw
          go to 440
  430     wx2=0.5
          wx3=0.5
  440     zx(jx,jy)=wx2*za(jx,jy-1)+wx3*za(jx+1,jy-1)
          w2=abs(zb(jx-1,jy+2)-zb(jx-1,jy+1))
          w3=abs(zb(jx-1,jy)-zb(jx-1,jy-1))
          sw=w2+w3
          if(sw.lt..0000001) go to 450
          wy2=w2/sw
          wy3=w3/sw
          go to 460
c
  450     wy2=0.5
          wy3=0.5
  460     zy(jx,jy)=wy2*zb(jx-1,jy)+wy3*zb(jx-1,jy+1)
          zxy(jx,jy)=
     &    wy2*(wx2*zab(jx-1,jy-1) + wx3*zab(jx,jy-1)) +
     &    wy3*(wx2*zab(jx-1,jy)+wx3*zab(jx,jy))
  470   continue
c
c  - WHEN U(K) < X(1) OR U(K) > X(LX)
c
  480   continue
        if(ix.eq.lxp1) go to 530
        if(ix.ne.1) go to 590
        w2=a4*(3.0*a3+a4)
        w1=2.0*a3*(a3-a4)+w2
        do 500 jy=2,3
          zx(1,jy)=(w1*za(1,jy-1)+w2*za(2,jy-1))/(w1+w2)
          zy(1,jy)=zy(2,jy)+zy(2,jy)-zy(3,jy)
          zxy(1,jy)=zxy(2,jy)+zxy(2,jy)-zxy(3,jy)
          do 490 jx1=2,3
            jx=5-jx1
            zx(jx,jy)=zx(jx-1,jy)
            zy(jx,jy)=zy(jx-1,jy)
            zxy(jx,jy)=zxy(jx-1,jy)
  490     continue
  500   continue
        x3=x3-1.0/a4
        z33=z33-z3a2/a4
        do 510 jy=1,5
          zb(2,jy)=zb(1,jy)
  510   continue
        do 520 jy=2,4
          zb(1,jy)=zb(1,jy)-zab(1,jy-1)/a4
  520   continue
        a3=a4
        jx=1
        go to 570
c
  530   w4=a2*(3.0*a3+a2)
        w5=2.0*a3*(a3-a2)+w4
        do 550 jy=2,3
          zx(4,jy)=(w4*za(4,jy-1)+w5*za(5,jy-1))/(w4+w5)
          zy(4,jy)=zy(3,jy)+zy(3,jy)-zy(2,jy)
          zxy(4,jy)=zxy(3,jy)+zxy(3,jy)-zxy(2,jy)
          do 540 jx=2,3
            zx(jx,jy)=zx(jx+1,jy)
            zy(jx,jy)=zy(jx+1,jy)
            zxy(jx,jy)=zxy(jx+1,jy)
  540     continue
  550   continue
        x3=x4
        z33=z43
        do 560 jy=1,5
          zb(1,jy)=zb(2,jy)
  560   continue
        a3=a2
        jx=3
  570   za(3,1)=za(jx+1,1)
        do 580 jy=1,3
          zab(2,jy)=zab(jx,jy)
  580   continue
c
c  - WHEN V(K) < Y(1) OR V(K) > Y(LY)
c
  590   if(iy.eq.lyp1) go to 630
        if(iy.ne.1) go to 680
        w2=b4*(3.0*b3+b4)
        w1=2.0*b3*(b3-b4)+w2
        do 620 jx=2,3
          if(jx.eq.3.and.ix.eq.lxp1) go to 600
          if(jx.eq.2.and.ix.eq.1) go to 600
          zy(jx,1)=(w1*zb(jx-1,1)+w2*zb(jx-1,2))/(w1+w2)
          zx(jx,1)=zx(jx,2)+zx(jx,2)-zx(jx,3)
          zxy(jx,1)=zxy(jx,2)+zxy(jx,2)-zxy(jx,3)
  600     do 610 jy1=2,3
            jy=5-jy1
            zy(jx,jy)=zy(jx,jy-1)
            zx(jx,jy)=zx(jx,jy-1)
            zxy(jx,jy)=zxy(jx,jy-1)
  610     continue
  620   continue
        y3=y3-1.0/b4
        z33=z33-z3b2/b4
        z3a3=z3a3-za3b2/b4
        z3b3=z3b2
        za3b3=za3b2
        b3=b4
        go to 670
c
  630   w4=b2*(3.0*b3+b2)
        w5=2.0*b3*(b3-b2)+w4
        do 660 jx=2,3
          if(jx.eq.3.and.ix.eq.lxp1) go to 640
          if(jx.eq.2.and.ix.eq.1) go to 640
          zy(jx,4)=(w4*zb(jx-1,4)+w5*zb(jx-1,5))/(w4+w5)
          zx(jx,4)=zx(jx,3)+zx(jx,3)-zx(jx,2)
          zxy(jx,4)=zxy(jx,3)+zxy(jx,3)-zxy(jx,2)
  640     do 650 jy=2,3
            zy(jx,jy)=zy(jx,jy+1)
            zx(jx,jy)=zx(jx,jy+1)
            zxy(jx,jy)=zxy(jx,jy+1)
  650     continue
  660   continue
        y3=y4
        z33=z33+z3b3/b3
        z3a3=z3a3+za3b3/b3
        z3b3=z3b4
        za3b3=za3b4
        b3=b2
  670   if(ix.ne.1.and.ix.ne.lxp1) go to 680
        jx=ix/lxp1+2
        jx1=5-jx
        jy=iy/lyp1+2
        jy1=5-jy
        zx(jx,jy)=zx(jx1,jy)+zx(jx,jy1)-zx(jx1,jy1)
        zy(jx,jy)=zy(jx1,jy)+zy(jx,jy1)-zy(jx1,jy1)
        zxy(jx,jy)=zxy(jx1,jy)+zxy(jx,jy1)-zxy(jx1,jy1)
c
c  DETERMINATION OF THE COEFFICIENTS OF THE POLYNOMIAL
c
  680   zx3b3=(zx34-zx33)*b3
        zx4b3=(zx44-zx43)*b3
        zy3a3=(zy43-zy33)*a3
        zy4a3=(zy44-zy34)*a3
        a=za3b3-zx3b3-zy3a3+zxy33
        b=zx4b3-zx3b3-zxy43+zxy33
        c=zy4a3-zy3a3-zxy34+zxy33
        d=zxy44-zxy43-zxy34+zxy33
        e=a+a-b-c
        a3sq=a3*a3
        b3sq=b3*b3
        p02=(2.0*(z3b3-zy33)+z3b3-zy34)*b3
        p03=(-2.0*z3b3+zy34+zy33)*b3sq
        p12=(2.0*(zx3b3-zxy33)+zx3b3-zxy34)*b3
        p13=(-2.0*zx3b3+zxy34+zxy33)*b3sq
        p20=(2.0*(z3a3-zx33)+z3a3-zx43)*a3
        p21=(2.0*(zy3a3-zxy33)+zy3a3-zxy43)*a3
        p22=(3.0*(a+e)+d)*a3*b3
        p23=(-3.0*e-b-d)*a3*b3sq
        p30=(-2.0*z3a3+zx43+zx33)*a3sq
        p31=(-2.0*zy3a3+zxy43+zxy33)*a3sq
        p32=(-3.0*e-c-d)*b3*a3sq
        p33=(d+e+e)*a3sq*b3sq
c
c  COMPUTATION OF THE POLYNOMIAL
c
  690   dy=vk-y3
        q0=p00+dy*(p01+dy*(p02+dy*p03))
        q1=p10+dy*(p11+dy*(p12+dy*p13))
        q2=p20+dy*(p21+dy*(p22+dy*p23))
        q3=p30+dy*(p31+dy*(p32+dy*p33))
        dx=uk-x3
        w(k)=q0+dx*(q1+dx*(q2+dx*q3))
  700 continue
c
c  NORMAL EXIT
c
      return
c
c  ERROR EXIT
c
  710 write(*,9999)
      go to 800
c
  720 write(*,9998)
      go to 800
c
  730 write(*,9997)
      go to 800
c
  740 write(*,9996)
      go to 760
c
  750 write(*,9995)
  760 write(*,9994)ix,x(ix)
      go to 800
c
  770 write(*,9993)
      go to 790
c
  780 write(*,9992)
  790 write(*,9991) iy,y(iy)
  800 write(*,9990) lx0,ly0,n0
      return
c
 9999 format(1x/22h       lx = 1 or less./)
 9998 format(1x/22h       ly = 1 or less./)
 9997 format(1x/21h       n = 0 or less./)
 9996 format(1x/26h       identical x values./)
 9995 format(1x/32h       x values out of sequence./)
 9994 format(7h   ix =,i6,10x,7hx(ix) =,e12.3)
 9993 format(1x/26h       identical y values./)
 9992 format(1x/32h       y values out of sequence./)
 9991 format(7h   iy =,i6,10x,7hy(iy) =,e12.3)
 9990 format(7h   lx =,i6,10x,4hly =,i6,10x,3hn =,i7/15h error detected
     &,20hin routine    itplbv)
c
      end
      subroutine hms(total_seconds, components)
      integer components(3), total_seconds
      components(1) = total_seconds/3600
      components(2) = mod(total_seconds, 3600)/60
      components(3) = mod(total_seconds, 60)
      return
      end

      subroutine hms_from_hours(hours, components)
      integer components(3), total_seconds
      total_seconds = nint(3600*hours)
      components(1) = hours
      components(2) = mod(total_seconds, 3600)/60
      components(3) = mod(total_seconds, 60)
      return
      end
